<?php
error_reporting(E_ALL & ~E_NOTICE);
define('ok', true);
header('Access-Control-Allow-Origin', '*');
header("Content-Type: text/html;charset=utf-8");
date_default_timezone_set('PRC');

class UploadImage
{
    private $pdo;

    public function __construct($pdo)
    {
        $this->pdo = $pdo;
    }

    public function upload($openid, $host, $code)
    {
        $result = array(
            'state' => 0,
            'msg' => 'get error'
        );
        $result['getDate'] = date('Y-m-d H:i:s') . "";
        if (is_uploaded_file($code['tmp_name'])) {
            //把文件转存到你希望的目录（不要使用copy函数）  
            $uploaded_file = $code['tmp_name'];
            //我们给每个用户动态的创建一个文件夹  
            $user_path = dirname(dirname(__FILE__)) . "/" . "upload/";
            //判断该用户文件夹是否已经有这个文件夹  
            if (!file_exists($user_path)) {
                mkdir($user_path, 0777, true);
            }
            //$move_to_file=$user_path."/".$code['name'];  
            $file_true_name = $code['name'];
            $file_path = $openid . "_" . time() . substr($file_true_name, strrpos($file_true_name, ".")); //strrops($file_true,".")查找“.”在字符串中最后一次出现的位置  
            $move_to_file = $user_path . $file_path;
            //判断是否已经存在这个文件
            if (!file_exists($move_to_file)) {
                //移动上传并重命名文件到文件夹 
                if (move_uploaded_file($uploaded_file, iconv("utf-8", "gb2312", $move_to_file))) {
                    // echo $code['name'] . "--上传成功" . date("Y-m-d H:i:sa");
                    $info = $this->insertImage($openid, $file_path, $host);
                    $result['msg'] = 'upload success';
                }
            } else {
                $info = $this->insertImage($openid, $file_path, $host);
                $result['msg'] = 'success';
            }
            $result['state'] = 1;
            $result['data'] = $info;
        }
        return $result;
    }

    //新增图片
    public function insertImage($openid, $file_path, $host)
    {
        $insertArr = array(
            'avatarUrl' => $host . "upload/" . $file_path
        );
        $where = "`openid`='" . $openid . "'";
        $this->pdo->update("user_info", $insertArr, $where);
        return $insertArr;
    }
}
require_once './cfgSQL.php';
require_once './MyPDO.php';
//参数
$openid = isset($_REQUEST["openid"]) ? $_REQUEST["openid"] : "";
$host = isset($_REQUEST["host"]) ? $_REQUEST["host"] : "";
$code = $_FILES['file']; //获取小程序传来的图片
if (!isset($code)) { //假如是删除的情况code则代码删除的图片路径
    $code = isset($_REQUEST["code"]) ? $_REQUEST["code"] : "";
}
if (empty($openid)) {
    exit('{"code": -1,"msg": "参数不能为空"}');
}
//
$pdo = DAOPDO::getInstance(DB_HOST, DB_USER, DB_PASS, DB_NAME, 'utf8');
$userInfo = new UploadImage($pdo);
$signPackage = $userInfo->upload($openid, $host, $code);
$result = json_encode($signPackage);
echo $result;
