<?php
error_reporting(E_ALL & ~E_NOTICE);
define('ok', true);
header('Access-Control-Allow-Origin', '*');
header("Content-Type: text/html;charset=utf-8");
date_default_timezone_set('PRC');

class GetUserInfo
{
    private $pdo;

    public function __construct($pdo)
    {
        $this->pdo = $pdo;
    }

    public function setInfo($openid)
    {
        $result = array(
            'state' => 1,
            'msg' => 'get'
        );
        $time = date('Y-m-d H:i:s') . "";
        $result["getTime"] = $time;
        //
        if (empty($openid)) {
            return $result;
        }
        $st = $this->pdo->prepareSql("select id,unionid,openid,avatarUrl,qrcodeUrl,commentCnt,nickName,score,name,phone from user_info where openid =?");
        $st->bindParam(1, $openid);
        $st->execute();
        $data2 = $st->fetchAll(PDO::FETCH_ASSOC)[0];
        if (!empty($data2)) {
            $result['state'] = 1;
            $result['msg'] = "get success";
            $result['data'] = $data2;
        }
        return $result;
    }
}
require_once './cfgSQL.php';
require_once './MyPDO.php';
//参数
$openid = isset($_REQUEST["openid"]) ? $_REQUEST["openid"] : "";
if (empty($openid)) {
    exit('{"code": -1,"msg": "参数不能为空"}');
}
//
$pdo = DAOPDO::getInstance(DB_HOST, DB_USER, DB_PASS, DB_NAME, 'utf8');
$userInfo = new GetUserInfo($pdo);
$signPackage = $userInfo->setInfo($openid);
$result = json_encode($signPackage);
echo $result;
