<?php
error_reporting(E_ALL & ~E_NOTICE);
define('ok', true);
header('Access-Control-Allow-Origin', '*');
header("Content-Type: text/html;charset=utf-8");
date_default_timezone_set('PRC');

class setUserInfo
{
    private $pdo;

    public function __construct($pdo)
    {
        $this->pdo = $pdo;
    }

    public function setUserInfo($openid, $para)
    {
        $result = array(
            'state' => 0,
            'msg' => 'get error'
        );
        //解析$para
        $para = json_decode($para);
        $updateArr = null;
        foreach ($para as $key => $value) {
            if ($key == "name" || $key == "region" || $key == "address") {
                $updateArr["" . $key] = urldecode($value);
            } else {
                $updateArr["" . $key] = $value;
            }
        }
        $where = "`openid`='" . $openid . "'";
        $flag = $this->pdo->update("user_info", $updateArr, $where);
        //返回数据
        if (!empty($flag)) {
            $result['state'] = 1;
            $result['msg'] = "信息提交成功！";
        } else {
            $result['state'] = 1;
            $result['msg'] = "已存在相同信息！";
        }
        $data2 = $this->getUsrInfo($openid);
        $result['data'] = $data2;
        $time = date('Y-m-d H:i:s') . "";
        $result['geDate'] = $time;
        return $result;
    }

    public function getUsrInfo($openid)
    {
        //返回当前用户数据
        $st = $this->pdo->prepareSql("select id,unionid,openid,avatarUrl,qrcodeUrl,commentCnt,nickName,score,name,phone,userId from user_info where openid =?");
        $st->bindParam(1, $openid);
        $st->execute();
        $data2 = $st->fetchAll(PDO::FETCH_ASSOC)[0];
        return $data2;
    }
}
require_once './cfgSQL.php';
require_once './MyPDO.php';
//参数
$openid = isset($_REQUEST["openid"]) ? $_REQUEST["openid"] : "";
$para = isset($_REQUEST["para"]) ? $_REQUEST["para"] : "";
if (empty($openid)) {
    exit('{"code": -1,"msg": "参数不能为空"}');
}
//
$pdo = DAOPDO::getInstance(DB_HOST, DB_USER, DB_PASS, DB_NAME, 'utf8');
$userInfo = new setUserInfo($pdo);
$signPackage = $userInfo->setUserInfo($openid, $para);
$result = json_encode($signPackage);
echo $result;
